<?php
define("DB_HOST", '127.0.0.1');
define("DB_FILE", 'd:\RINO\Win_amk\DataBases\Test\TEST.GDB?charset=UTF8&dialect=1');
//define("DB_HOST", '192.168.1.16');
//define("DB_FILE", '/data/base/billing.fdb?charset=UTF8&dialect=1');
define("DB_USER", 'SYSDBA');
define("DB_PASS", 'q');
define("DB_ENGINE", 'ibase(firebird)');

define("MAX_STATISTICS_ROWS", 1000);
define("MAX_CHANGELOG_ROWS", 1000);
define("PHONE_NUMBER_PREFIX", '7');

define("URL_PROMOLOGIN", 'tm');
define("URL_PROMOLOGOUT", 'index');
//define("URL_PROMOLOGOUT", '/');

/**
 * DB misc
 */
define("DB_SERVICEID_MTR", 11);
define("DB_SERVICEID_MSG_IN", 3);
define("DB_SERVICEID_MSG_OUT", 4);

/**
 * TM
 */
define("DB_TM_CALL_PROJECT_ID", 4);
define("DB_TM_CALL_TRY_COUNT", 1);
define("DB_TM_CALL_PARAMS", <<<EOS
User.NumberB=%NumberB%
Def.Lang=2
InCall.AON=4952293897
InCall.AONIndex=0
InCall.NumberIn=000009
User.Flags=6
EOS
);

/* task statuses */
define("TMS_STATUS_READY_FOR_DIAL", 0);
define("TMS_STATUS_WAIT_FOR_DIAL", 1);
define("TMS_STATUS_DIALING", 2);
define("TMS_STATUS_DIAL_PAUSE", 3);
define("TMS_STATUS_TECH_BLOCK", 4);
define("TMS_STATUS_COMPLETE", 100);
define("TMS_STATUS_STOP_DIAL_LIMIT", 101);
define("TMS_STATUS_STOP_BLOCKING", 102);
define("TMS_STATUS_INSERTED", 200);
define("TMS_STATUS_UPDATED", 201);

$GLOBALS['_TM_task_status_description'] = array(
	TMS_STATUS_READY_FOR_DIAL => 'Подготовка к набору номера',
	TMS_STATUS_WAIT_FOR_DIAL => 'Ожидание набора номера',
	TMS_STATUS_DIALING => 'Набор номера',
	TMS_STATUS_DIAL_PAUSE => 'Пауза перед очередной попыткой набора',
	TMS_STATUS_TECH_BLOCK => 'Системная ошибка при дозвоне',
	TMS_STATUS_COMPLETE => 'Дозвон успешно завершен',
	TMS_STATUS_STOP_DIAL_LIMIT => 'Достигнут лимит попыток дозвона',
	TMS_STATUS_STOP_BLOCKING => 'Отмечена администратором как завершенная',
	TMS_STATUS_INSERTED => 'Задача создана',
	TMS_STATUS_UPDATED => 'Задача изменена'
);

function task_status_str($status) {
	if (isset($GLOBALS['_TM_task_status_description'][$status]))
		return $GLOBALS['_TM_task_status_description'][$status];
	else
		return $status;
}

/* task dial statuses */
define("TMD_STATUS_ANSWER", 0);
define("TMD_STATUS_NO_EVENT", -1);
define("TMD_STATUS_NO_LINE", -2);
define("TMD_STATUS_SYS_TERM", -3);
define("TMD_STATUS_AUTH_FAIL", -7);
define("TMD_STATUS_SERV_FAIL", -8);
define("TMD_STATUS_TAR_OPEN", -9);
define("TMD_STATUS_NOANSWER", -10);
define("TMD_STATUS_BAD_NUM", -11);

$GLOBALS['_TM_dial_status_description'] = array(
	TMD_STATUS_ANSWER => 'Вызываемая сторона ответила',
	TMD_STATUS_AUTH_FAIL => 'Ошибка авторизации по указанным параметрам',
	TMD_STATUS_NO_EVENT => 'Событие проекта не обрабатывается',
	TMD_STATUS_NO_LINE => 'Нет свободных линий для дозвона',
	TMD_STATUS_SERV_FAIL => 'Ошибка создания услуги',
	TMD_STATUS_SYS_TERM => 'Вызов прерван системой',
    TMD_STATUS_TAR_OPEN => 'Ошибка создания тарифной сессии',
    TMD_STATUS_NOANSWER => 'Абонент не ответил',
    TMD_STATUS_BAD_NUM => 'Некорректный номер'
);

function dial_status_str($status) {
	if (isset($GLOBALS['_TM_dial_status_description'][$status]))
		return $GLOBALS['_TM_dial_status_description'][$status];
	else {
        if ($status > 0) {
            return "Канальная занятость ($status)";
        } else {
		    if (isset($status)) {
                return "Неизвестный статус ($status)";
		    } else {
                return $status;
            }
        }
    }
}

/* task result status */
define("TMR_STATUS_NONE", null);
define("TMR_STATUS_ANSWER", 0);
define("TMR_STATUS_LISTEN_HI", 1);
define("TMR_STATUS_LISTEN_GOAL", 2);
define("TMR_STATUS_CONFIRM", 3);

$GLOBALS['_TM_result_status_description'] = array(
	TMR_STATUS_NONE => 'Не определен',
	TMR_STATUS_ANSWER => 'Вызываемая сторона ответила',
	TMR_STATUS_LISTEN_HI => 'Прослушали приветствие',
	TMR_STATUS_LISTEN_GOAL => 'Прослушали сообщение',
	TMR_STATUS_CONFIRM => 'Подтвердили прослушивание'
);

function result_status_str($status) {
	if (isset($GLOBALS['_TM_result_status_description'][$status]))
		return $GLOBALS['_TM_result_status_description'][$status];
	else
		return "Неизвестный код ($status)";
}

/**
 * Misc
 */
define("DB_TAR_DEBUG", false);
define("DB_TAR_DEBUG_NUMBER", '');

/**
 * Global site
 */
define("SITE_COPYRIGHT", '© 2008-2011 ЗАО «НПП «РИНО»');

/**
 * Database Table
 */
define("TB_WEB_CACHE", "tb_web_access");
define("TB_WEB_LOG", "tb_web_log");

/**
 * Special Names and Levels
 */
define("GUEST_NAME", "guest");

define("GUEST_LEVEL", -1);  //project unavailable for this user
define("ADMIN_LEVEL", 1);  //project admin
define("OPER_LEVEL", 0);  //project reader

/**
 * Timeouts
 */
define("USER_TIMEOUT", 10);
define("GUEST_TIMEOUT", 5);

/**
 * Cookies
 */
define("COOKIE_EXPIRE", 60 * 60 * 24 * 30); //30 days by default
//define("COOKIE_PATH", "/");  //Available in whole domain
define("COOKIE_PATH", "/");
define("COOKIE_NAME_WEBID", "tmid");
define("COOKIE_NAME_WEBIDR", "tmidr");

/**
 * Email
 */
define("EMAIL_FROM_NAME", "TM");
define("EMAIL_FROM_ADDR", "noreply@address.com");

/**
 * Logger
 */
require_once 'Log.php';
$conf = array('mode' => 0600, 'dirmode' => 0755, 'timeFormat' => '%d.%m.%Y %H:%M:%S');
$logger = &Log::singleton('file', 'tm.log', '', $conf);
?>
