function ui_block() {
	$.blockUI({
		baseZ: 99999,
		overlayCSS: {
			backgroundColor: '#fff',
			opacity: 0.1,
			cursor: 'wait'
		},
		css: {
			border: 'none',
			backgroundColor: '#333',
			opacity: 0.9,
			color: '#000',
			width: '208px',
			padding:	0,
			margin:		0,
			top:		'54px',
			left:		'41%',
			textAlign:	'center',
			cursor:		'wait'
		},
		message: '<img src="images/pbari.gif">'
	});
}

function ui_unblock() {
	$.unblockUI();
}

function hidemsg() {
	$('#authmessage').fadeOut('slow');
}

function cookies_enabled() {
	var tcn = 'tc';
	$.cookie(tcn, true, { expires: 1, path: '/' });
	if ($.cookie(tcn)) {
		$.cookie(tcn, null);
		return true;
	}
	return false;
}

$(document).ready(function() {
	$('.pwdclose').click(function() {
		$(this).parent().fadeOut('slow');
		return false;
	});

	$('.forgotpwd > a').click(function() {
		$('#authpwdinfo').fadeIn('slow');
		return false;
	});

	$('#auth_do').click(function() {
		if ($('#authlogin').val().length < 1 || $('#authpwd').val().length < 1 ) {
			$('#authmessage').removeClass().addClass('authmessagetext').html('Заданы не все параметры авторизации!')
				.fadeIn('fast', function(){setTimeout('hidemsg();', 5000);});
			if ($('#authlogin').val().length < 1)
				$('#authlogin').focus();
			else
			if ($('#authpwd').val().length < 1)
				$('#authpwd').focus();
			return false;
		}

		if (!cookies_enabled() && !confirm('В вашем браузере отключена поддержка cookies! Полный функционал сайта будет недоступен. Всё равно продолжить?'))
			return false;

		$('#authmessage').empty().removeClass().addClass('authmessageprogress').fadeIn('fast');
		$('#authlogin').attr('disabled', 'disabled');
		$('#authpwd').attr('disabled', 'disabled');
		$('#auth_do').attr('disabled', 'disabled').addClass('disabled');
		$.ajax({
			type: 'POST',
			url: 'process',
			data: ({op:'auth',
				login: $('#authlogin').val(),
				pwd: $('#authpwd').val(),
				red: '1',
				remember: $('#authrem:checked').val() != null}),
			dataType: 'json',
			async: true,
			success: function(data) {
				$('#authmessage').empty();
				$('#authpwd').val('');
				$('#authlogin').removeAttr('disabled');
				$('#authpwd').removeAttr('disabled');
				if (data.error) {
					$('#authmessage').removeClass().addClass('authmessagetext')
							.html(data.error)
							.fadeIn('fast', function(){setTimeout('hidemsg();', 5000);});
					$('#authlogin').focus();
					$('#auth_do').removeAttr('disabled').removeClass('disabled');
				} else {
					/*$('#authmessage').removeClass().html('Авторизация успешна')
							.fadeIn('fast', function(){setTimeout('hidemsg();', 5000);});*/
					window.location.href = data.red;
				}
			}
		});
		return false;
	});

	$('#authlogin').keypress(function(e) {
		if (e.which == 13) {
			if ($(this).val().length > 0)
				$('#authpwd').focus();
				//$('#auth_do').click();
		}
		return true;
	});

	$('#authpwd').keypress(function(e) {
		if (e.which == 13 && $(this).val().length > 0) {
			$('#auth_do').click();
			return false;
		}
		//if((e.which >= 48 && e.which <= 57) || e.which == 8|| e.which==9|| e.which==118|| e.which===0) return true;
		return true;
	});
});
