var progressnotify_count = 0;
function progressnotify_start() {
	progressnotify_count++;
	if (progressnotify_count == 1)
		$('#progressnotifier').show();
}
function progressnotify_stop(completestop) {
	progressnotify_count--;
	if (completestop || progressnotify_count <= 0) {
		progressnotify_count = 0;
		$('#progressnotifier').hide();
	}
}

function update_all() {
	$('#preloader').fadeOut(700);
	update_status(true);
}

function ui_block() {
	$.blockUI({
		baseZ: 99999,
		overlayCSS: {
			backgroundColor: '#fff',
			opacity: 0.1,
			cursor: 'wait'
		},
		/*css: {
		 //border: 'none',
		 padding: '15px',
		 backgroundColor: '#fff',
		 '-webkit-border-radius': '10px',
		 '-moz-border-radius': '10px',
		 opacity: 0.9,
		 color: '#000',
		 width: '350px'
		 },
		 message: '<img src="images/pbari.gif"><br><span class="lg">&nbsp;Выполнение запроса...</span>'*/
		css: {
			border: 'none',
			backgroundColor: '#333',
			opacity: 0.9,
			color: '#000',
			width: '208px',
			padding:	0,
			margin:		0,
			top:		'54px',
			left:		'41%',
			textAlign:	'center',
			cursor:		'wait'
		},
		message: '<img src="images/pbari.gif">'
	});
}

function ui_unblock() {
	$.unblockUI();
}

function cookies_enabled() {
	var tcn = 'tc';
	$.cookie(tcn, true, { expires: 1, path: '/' });
	if ($.cookie(tcn)) {
		$.cookie(tcn, null);
		return true;
	}
	return false;
}

// Simple JavaScript Templating
// John Resig - http://ejohn.org/ - MIT Licensed
(function() {
	var cache = {};

	this.tmpl = function tmpl(str, data) {
		// Figure out if we're getting a template, or if we need to
		// load the template - and be sure to cache the result.
		var fn = !/\W/.test(str) ?
			cache[str] = cache[str] ||
				tmpl(document.getElementById(str).innerHTML) :

			// Generate a reusable function that will serve as a template
			// generator (and which will be cached).
				new Function("obj",
					"var p=[],print=function(){p.push.apply(p,arguments);};" +

						// Introduce the data as local variables using with(){}
							"with(obj){p.push('" +

						// Convert the template into pure JavaScript
							str
								.replace(/[\r\t\n]/g, " ")
								.split("<%").join("\t")
								.replace(/((^|%>)[^\t]*)'/g, "$1\r")
								.replace(/\t=(.*?)%>/g, "',$1,'")
								.split("\t").join("');")
								.split("%>").join("p.push('")
								.split("\r").join("\\'")
							+ "');}return p.join('');");

		// Provide some basic currying to the user
		return data ? fn(data) : fn;
	};
})();

function update_status(firsttime) {
	$.ajax({
		type: 'POST',
		url: 'process',
		data: ({op:'check_status'}),
		dataType: 'json',
		async: true,
		success: function(data) {
			var st = true;
			if (data.error) {
				if (data.auth == 0) {
					st = false;
					$('#shutter').show();
					setTimeout("show_auth();", 200);
				}
			} else {
				$('#cm_whoami').html(data.whoami);
				if (data.params)
					$.each(data.params, function (pname, pvalue) {
						$('#' + pname).val(pvalue);
					});
				if ($('#shutter').is(':visible'))
					projlist.flexReload();//timer_projects_start();
				$('#shutter').hide();
			}
			if (st)
				setTimeout("update_status();", 60000);
		}
	});
}

var projlist = null, projtasks = null;
var active_project_id = null;
var timer_tasks = null, timer_projects = null;
var selection_tasks = null, selection_projects = null;

function timer_projects_stop() {
	if (timer_projects !== null) {
		clearTimeout(timer_projects);
		timer_projects = null;
	}
}
function timer_projects_start() {
	timer_projects_stop();

	//if ($('#projlist > tbody > tr').length > 0)
	if ($('#mon_aupd').is(':checked') && !$('#shutter').is(':visible'))
		timer_projects = setTimeout('projlist.flexReload();', 10 * 1000);
}
function timer_tasks_stop() {
	if (timer_tasks !== null) {
		clearTimeout(timer_tasks);
		timer_tasks = null;
	}
}
function timer_tasks_start() {
	timer_tasks_stop();

	//if ($('#projtasks > tbody > tr').length > 0)
	if ($('#mon_aupd').is(':checked') && !$('#shutter').is(':visible'))
		timer_tasks = setTimeout('projtasks.flexReload();', 10*1000);
}

function updateProjectsToolbar() {
	//var selection = $('#projlist .trSelected', projlist);
	var selection = $('.trSelected', projlist);
	if (selection.length == 0)
		projlist.flexShowToolbarButton(-1, false);
	else {
		var recs = selection.children('td');
		var isactive = $(recs[0]).children('div').html().indexOf('inactive') == -1;
		projlist.flexShowToolbarButton(4, true);
		projlist.flexShowToolbarButton(3, true);
		projlist.flexShowToolbarButton(2, true);
		projlist.flexShowToolbarButton(1, isactive);
		projlist.flexShowToolbarButton(0, !isactive);
	}
}

function updateTasksToolbar() {
	var selection = $('.trSelected', projtasks);
	if (selection.length == 0)
		projtasks.flexShowToolbarButton(-1, false);
	else {
		var recs = selection.children('td');
		recs = $(recs[0]).children('div').html();
		var isactive = recs.indexOf('check') == -1;
		var isunknown = recs.indexOf('unknown') != -1;
		projtasks.flexShowToolbarButton(3, true);
		projtasks.flexShowToolbarButton(2, true);
		projtasks.flexShowToolbarButton(1, isunknown || isactive);
		projtasks.flexShowToolbarButton(0, isunknown || !isactive);
	}
}

function preProcessProjectsData(data) {
	if (data.rows.length == 0) {
		selection_projects = null;
		active_project_id = null;
		$("#projtasks").flexUnBlock();
		if ($('#projtasks > tbody > tr').length > 0)
			$("#projtasks").flexReload();
		$("#projtasks").parent().parent().hide();
		timer_projects_start();
		$("#projlist > tbody").empty();
		updateProjectsToolbar();
	}
	return data;
}

function preProcessTasksData(data) {
	if (data.rows.length == 0) {
		selection_tasks = null;
		$("#projlist").flexUnBlock();
		timer_projects_start();
		//timer_tasks_start();
		$("#projtasks > tbody").empty();
		updateTasksToolbar();
	}
	return data;
}

function showTaskStats(taskid) {
	show_taskstats(taskid);
	return true;
}

function showTaskProps(taskid) {
	show_taskprops(taskid);
	return true;
}

function showTasksLoad() {
	show_tasksload(active_project_id);
	return true;
}

function showProjectStats() {
	show_projectstats(active_project_id);
	return true;
}

function prj_toolbar_cmd(cmdname, grid, cmdid) {
	switch (cmdid) {
		case 'bt_project_activate':
		case 'bt_project_deactivate':
			var selection = $('.trSelected', grid);
			if (selection.length == 0)
				return false;
			var recs = selection.children('td');
			var info = $(recs[1]).children('div').html();
			if (confirm(cmdname + ' "' + info + '"?')) {
				timer_projects_stop();
				var idlist = selection[0].id.substr(8);
				$.ajax({
					type: 'POST',
					url: 'process',
					data: ({op: 'project_activate', pids: idlist, opt: (cmdid.search('de') == -1)?'1':'0'}),
					dataType: 'json',
					success: function(data) {
						if (data.error) {
							alert(data.error);
						} else {
							projlist.flexReload();
						}
					}
				});
			}
			break;

		case 'bt_project_props':
			show_projectprops(active_project_id);
			break;

		case 'bt_project_stats':
			showProjectStats();
			break;

		case 'bt_project_uploadtasks':
			showTasksLoad();
			break;
	}
	return true;
}

function task_toolbar_cmd(cmdname, grid, cmdid) {
	var selection = $('.trSelected', grid);
	var idlist = (selection.length == 0) ? null : selection[0].id.substr(8);

	switch (cmdid) {
		case 'bt_task_start':
		case 'bt_task_stop':
			if (!idlist)
				return false;

			timer_projects_stop();
			$.ajax({
				type: 'POST',
				url: 'process',
				data: ({op: 'task_activate', tids: idlist, opt: (cmdid.search('stop') == -1)?'1':'0'}),
				dataType: 'json',
				success: function(data) {
					if (data.error) {
						alert(data.error);
						timer_projects_start();
					} else {
						projtasks.flexReload();
					}
				}
			});
			break;

		case 'bt_tasks_props':
			if (!idlist)
				return false;
			showTaskProps(idlist);
			break;

		case 'bt_task_stats':
			if (!idlist)
				return false;
			showTaskStats(idlist);
			break;
	}
	return true;
}

function update_project_snapshots(update_tasks) {
	if (parseInt(active_project_id) >= 0) {
		$('#projsnapshot').empty().html('<option>Обновление....</option>');
		$.ajax({
			type:'POST',
			url:'process',
			data: ({op:'project_snapshots_list',pid:active_project_id}),
			dataType:'json',
			async:true,
			success:function (data) {
				if (data.error) {
					alert(data.error);
				} else {
					if (data.pid == active_project_id && data.snapshots) {
						var opts = '';
						$.each(data.snapshots, function (i, item) {
							opts += '<option value="' + item.id + '">' + item.name + '</option>';
						});
						$('#projsnapshot').html(opts).val(data.snapshotsa);
						if ($('#projsnapshot').val() != data.snapshotsa)
							$('#projsnapshot').val('0');
						//else
							//$('.sparkbox-custom').trigger('change');
						//$('#projsnapshot').MyDropdown();
						//$('.sparkbox-custom').sbCustomSelect();

						if (update_tasks) {
							timer_projects_stop();
							$("#projtasks").flexReload();
						}
					}
				}
			}
		});
	}
}

$(document).ready(function() {
	/*$.ajaxSetup({
	   cache: false
	});*/
	$(document).ajaxStart(function(){
		progressnotify_start();
	});
	$(document).ajaxStop(function(){
		progressnotify_stop();
		$.unblockUI();
	});

	$.dpText.TEXT_PREV_YEAR = 'Предыдущий год';
	$.dpText.TEXT_PREV_MONTH = 'Предыдущий месяц';
	$.dpText.TEXT_NEXT_YEAR = 'Следующий год';
	$.dpText.TEXT_NEXT_MONTH = 'Следующий месяц';
	$.dpText.TEXT_CLOSE = 'Закрыть';
	$.dpText.TEXT_CHOOSE_DATE = 'Выбрать дату';

	$('#dologin').click(function() {
		show_auth();
		return false;
	});

	$('#dologout, #cm_logout').click(function() {
		ui_block();
		$.ajax({
			type: 'POST',
			url: 'process',
			data: ({op:'deauth'}),
			dataType: 'json',
			async: true,
			success: function(data) {
				//update_all();
				//ui_unblock();
				window.location.href = data.red;
			}
		});
		return false;
	});

	$("#projlist").flexigrid({
		url: 'process',
		params: [{name: 'op', value: 'project_list'}],
		dataType: 'json',
		colModel: [
			{display: '&nbsp;', name: 'flags', width: 14, sortable: false, align: 'right'},
			{display: 'Название проекта', name: 'tm_project_name', width: 250, sortable: false, align: 'left'},
			{display: 'Дата начала', name: 'tm_project_start_time', width: 110, sortable: false, align: 'right'},
			{display: 'Дата завершения', name: 'tm_project_stop_time', width: 110, sortable: false, align: 'right'},
			{display: 'Активных задач', name: 'tm_tasks_active', width: 100, sortable: false, align: 'right'},
			{display: 'Завершено задач', name: 'tm_tasks_done', width: 100, sortable: false, align: 'right'}
			],
		buttons: [
			{name: 'Запустить проект', cmd: 'bt_project_activate', bclass: 'btaccept', onpress: prj_toolbar_cmd},
			{name: 'Остановить проект', cmd: 'bt_project_deactivate', bclass: 'btdel', onpress: prj_toolbar_cmd},
			{separator: true},
			{name: 'Параметры проекта', cmd: 'bt_project_props', bclass: 'btoptions', onpress: prj_toolbar_cmd},
			{separator: true},
			{name: 'Статистика по проекту', cmd: 'bt_project_stats', bclass: 'btstats', onpress: prj_toolbar_cmd},
			{separator: true},
			{name: 'Загрузить задачи', cmd: 'bt_project_uploadtasks', bclass: 'btupload', onpress: prj_toolbar_cmd}
			],
		sortname: "tm_project_start_time",
		sortorder: "desc",
		title: 'Проекты',
		showToggleBtn: false,
		singleSelect: true,
		striped: false,
		usepager: true,
		useRp: true,
		rp: 30,
		rpOptions: [10,20,25,30,50,90],
		showTableToggleBtn: false,
		width: 'auto',
		height: 140,
		resizable: true,
		errormsg: 'Список проектов в данный момент недоступен. Попробуйте позже.',
		pagestat: 'Отображены проекты с {from} по {to} из {total}',
		pagetext: 'Страница',
		outof: 'из',
		findtext: 'Поиск&nbsp;',
		procmsg: 'Обновление списка...',
		rphint: 'Количество записей на странице',
		reloadhint: 'Обновить данные',
		nomsg: 'Список проектов пуст',
		autoload: false,
		preProcess: preProcessProjectsData,
		onSuccess: function() {
			$("#projtasks").flexUnBlock();
			if (selection_projects !== null) {
				$('#' + selection_projects).addClass('trSelected');

				active_project_id = $('#' + selection_projects).hasClass('trSelected') ?
					parseInt(selection_projects.substr(8)) : null;
			}
			if (parseInt(active_project_id) >= 0) {
				//timer_projects_stop();
				//$("#projtasks").flexReload();
				update_project_snapshots(true);
			} else
				timer_projects_start();

			updateProjectsToolbar();
		},
		onSubmit: function() {
			$("#projtasks").flexBlock();
			timer_projects_stop();
			return true;
		},
		onClick: function(row) {
			selection_projects = $(row).hasClass('trSelected') ? row.id : null;

			active_project_id = $(row).hasClass('trSelected') ? parseInt(row.id.substr(8)) : null;
			if (parseInt(active_project_id) >= 0)
				$("#projtasks").parent().parent().fadeIn('fast', function() {
					//timer_projects_stop();
					//$("#projtasks").flexReload();
					update_project_snapshots(true);
				});
			else
				$("#projtasks").parent().parent().fadeOut('fast');

			updateProjectsToolbar();
		},
		onDblClick: function(row) {
			showProjectStats();
		}
	});
	projlist = $("#projlist");

	var title = $('.ftitle', projlist.parent().parent())[0];
	$(title).append(
		$('<span class="gridchecks">'+
			'<input type="checkbox" class="check alleft" name="mon_aupd" id="mon_aupd" />'+
			'<label for="mon_aupd" class="check alleft" title="Обновлять списки проектов и задач по таймеру">Обновлять автоматически</label>'+
			'</span>')
	);
	$('#mon_aupd').click(function(){
		if ($(this).is(':checked'))
			projlist.flexReload();//timer_projects_start();
		else {
			timer_projects_stop();
			timer_tasks_stop();
		}
	});

	$("#projtasks").flexigrid({
		url: 'process',
		params: [{name: 'op', value: 'project_task_list'}],
		dataType: 'json',
		colModel: [
			{display: '&nbsp;', name: 'flags', width: 14, sortable: false, align: 'right'},
			{display: 'Телефон', name: 'tm_task_dial_num', width: 90, sortable: false, align: 'right'},
			{display: 'Состояние задачи', name: 'tm_task_status', width: 200, sortable: false, align: 'left'},
			{display: 'Статус дозвона', name: 'tm_task_dial_cause', width: 170, sortable: false, align: 'left'},
			{display: 'Результат выполнения задачи', name: 'tm_task_result', width: 170, sortable: false, align: 'left'},
			{display: 'Повторов', name: 'tm_task_try_count', width: 60, sortable: false, align: 'right'}
			],
		buttons: [
			{name: 'Запустить задачу', cmd: 'bt_task_start', bclass: 'bttaskstart', onpress: task_toolbar_cmd},
			{name: 'Остановить задачу', cmd: 'bt_task_stop', bclass: 'bttaskstop', onpress: task_toolbar_cmd},
			{separator: true},
			{name: 'Параметры задачи', cmd: 'bt_tasks_props', bclass: 'btoptions', onpress: task_toolbar_cmd},
			{separator: true},
			{name: 'Статистика по задаче', cmd: 'bt_task_stats', bclass: 'btupdown', onpress: task_toolbar_cmd}
			],
		sortname: "tm_task_id",
		sortorder: "desc",
		title: 'Задачи выбранного проекта',
		showToggleBtn: false,
		singleSelect: true,
		striped: false,
		usepager: true,
		useRp: true,
		rp: 30,
		rpOptions: [10,20,25,30,50,90],
		showTableToggleBtn: false,
		width: 'auto',
		height: 150,
		resizable: true,
		errormsg: 'Список задач в данный момент недоступен. Попробуйте позже.',
		pagestat: 'Отображены задачи с {from} по {to} из {total}',
		pagetext: 'Страница',
		outof: 'из',
		findtext: 'Поиск&nbsp;',
		procmsg: 'Обновление списка...',
		rphint: 'Количество записей на странице',
		reloadhint: 'Обновить данные',
		nomsg: 'Список задач пуст',
		autoload: false,
		preProcess: preProcessTasksData,
		onSuccess: function() {
			if (selection_tasks !== null)
				$('#' + selection_tasks).addClass('trSelected');
			$("#projlist").flexUnBlock();
			timer_projects_start();
			//timer_tasks_start();
			updateTasksToolbar();
		},
		onSubmit: function() {
			timer_tasks_stop();
			$("#projlist").flexBlock();
			$("#projtasks").flexOptions({
				params: [
					{name: 'op', value: 'project_task_list'},
					{name: 'pid', value: active_project_id},
					{name: 'starttm', value: ''},
					{name: 'stoptm', value: ''},
					{name: 'flagsin', value: ''},
					//{name: 'tfilter_days', value: $('#tfilter_days').val()}
					{name: 'projsnapshot', value: $('#projsnapshot').val()}
				]
			});
			return true;
		},
		onClick: function(row) {
			selection_tasks = $(row).hasClass('trSelected') ? row.id : null;

			updateTasksToolbar();
		},
		onDblClick: function(row) {
			showTaskStats(row.id.substr(8));
		}
	});
	projtasks = $("#projtasks");
	projtasks.parent().parent().hide();

	title = $('.ftitle', projtasks.parent().parent())[0];
	/*$(title).append(
		$('<span class="gridselects">' +
			'<select id="tfilter_days" title="Отображение задач выполнявшихся в течение указанного периода">' +
				'<option value="0" selected>Все задачи</option>' +
				'<option value="31">За месяц</option>' +
				'<option value="7">За неделю</option>' +
				'<option value="2">За 2 дня</option>' +
				'<option value="1">За день</option>' +
			'</select>' +
			'</span>')
	);
	$('#tfilter_days').change(function() {
		if (!$('#mon_aupd').is(':checked'))
			projtasks.flexReload();
	});*/
	$(title).append(
		$('<span class="gridselects">' +
			'<select id="projsnapshot" class="sparkbox-custom" title="Список периодов работы проекта">' +
			'</select>' +
			'</span>')
	);
	//$(title).parent().css('overflow','visible');
	$('#projsnapshot').change(function() {
		$(this).blur();
		//if (!$('#mon_aupd').is(':checked'))
			projtasks.flexReload();
	});
	//$('.sparkbox-custom').sbCustomSelect();

	updateProjectsToolbar();
	updateTasksToolbar();

	$('a').each(function(index) {
		if ($(this).attr('href') && $(this).attr('rel') == 'external')
			$(this).attr('target', '_blank');
	});
});
