<?php
/**
 * widget_auth.php
 */
require_once(dirname(__FILE__) . '/include/session.php');

global $session, $database;
if (!$session->db_ok) {
	print('database not ok');
	die();
}

//sleep(5);
?>
<script type="text/javascript">
	$(document).ready(function() {
		$('#dialogauth').overlay().load();
	});

	$('#auth_do').click(function () {
		if ($('#authlogin').val().length < 1 || $('#authpwd').val().length < 1) {
			$('#authmessage').removeClass().addClass('authmessagetext').html('Заданы не все параметры авторизации!');
			if ($('#authlogin').val().length < 1)
				$('#authlogin').focus();
			else
			if ($('#authpwd').val().length < 1)
				$('#authpwd').focus();
			return false;
		}

		if (!cookies_enabled() && !confirm('В вашем браузере отключена поддержка cookies! Полный функционал сайта будет недоступен. Всё равно продолжить?'))
			return false;

		$('#authmessage').removeClass().addClass('authmessageprogress').html('<img src="images/pbari.gif">');
		$('#authlogin').attr('disabled', 'disabled');
		$('#authpwd').attr('disabled', 'disabled');
		$('#auth_do').attr('disabled', 'disabled').addClass('disabled');
		$.ajax({
			type: 'POST',
			url: 'process',
			data: ({op:'auth',
				login: $('#authlogin').val(),
				pwd: $('#authpwd').val(),
				remember: $('#authrem:checked').val() != null}),
			dataType: 'json',
			async: true,
			success: function(data) {
				$('#authmessage').empty();
				$('#authpwd').val('');
				$('#authlogin').removeAttr('disabled');
				$('#authpwd').removeAttr('disabled');
				if (data.error) {
					$('#authmessage').removeClass().addClass('authmessagetext')
							.html(data.error)
							.fadeIn(200);
					$('#authlogin').focus();
				} else {
					$('#authmessage').removeClass().html('');
					//.addClass('authmessagetext')
					//.html('Авторизация успешна. Приятной работы.')
					//.fadeIn(200);
					//ToDo: Successfull login tasks
					$('#dialogauth').overlay().close();
					//$('#shutter').fadeOut(500);
					update_all();
				}
				$('#auth_do').removeAttr('disabled').removeClass('disabled');
			}
		});
		return false;
	});

	$('#authlogin').keypress(function(e) {
		if (e.which == 13) {
			if ($(this).val().length > 0)
				$('#authpwd').focus();
			//$('#auth_do').click();
		}
		return true;
	});

	$('#authpwd').keypress(function(e) {
		if (e.which == 13 && $(this).val().length > 0) {
			$('#auth_do').click();
			return false;
		}
		//if((e.which >= 48 && e.which <= 57) || e.which == 8|| e.which==9|| e.which==118|| e.which===0) return true;
		return true;
	});
</script>

<div id="dlg_caption">Авторизация в системе</div>
<div id="auth_form">
	<fieldset>
		<p>
			<label for="authlogin">Пользователь</label>
			<input type="text" name="authlogin" id="authlogin" class="text"/>
		</p>

		<p>
			<label for="authpwd">Пароль</label>
			<input type="password" name="authpwd" id="authpwd" class="text"/>
			<!-- <br />
			<span id="forgotpwd">
				<a href="#" onClick="$('#authpwdinfo').toggle('slow');">Как узнать свой пароль?</a>
			</span> -->
		</p>

		<p>
			<label for="authrem"></label>
			<input type="checkbox" class="check" name="authrem" id="authrem"/>
			<label for="authrem" class="check alright">Запомнить</label>
		</p>
	</fieldset>
	<fieldset class="tiny">
		<p>
			<input type="image" class="button" id="auth_do" name="auth_do" value="Войти" src="images/btenter.gif"/>
		</p>
	</fieldset>
</div>
<div id="authmessage"></div>
<div id="authpwdinfo" style="display:none">
	Спросить у Гугеля.
</div>
